/*
    JV Library
    Copyright (C) 2014  Jouko Juhani Virtanen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _IOUtils_include_
#define _IOUtils_include_

# include "TypeDef.h"
# include "IOUtils.h"

bool exist(char charfile[1000]);
bool exist(string File);
void FileNotValid(string file, string FileType);
void OpenFile(string File, fstream &file, string FileType);
void OpenFileForWriting(string File, ofstream &file);
void readLines(string File, vector<string> &lines, string FileType);
void PrintLines(string File, vector<string> &lines);
bool isReal(string str);
string GetWord(string line, int WordNum);
bool GetLineInFile(string PdbFilePaths, string &line, int nthstruct);
bool GetLinesInFile(string FilePath, vector<string> &lines, int start, int end);
string IntToStr(int x);
string toStr(int x);
string RealToStr(Real x);
string toStr(Real x);
bool isNumber(string str);
void AddIndexToFile(string &str);
string GetWord2(string line, int WordNum);
string GetExtension(string file);
string removeExtension(string file);
string getBase(string file);
string GetDir(string file);
bool StrToBool(const string &str);
string BoolToStr(bool b);
Real StrToReal(string str);
Real toReal(string str);
int toInt(string str);
void Tokenize(string line, string str, vector<string> &v);
void DeleteFromLeft(string &line, string str);
bool DeleteFromLeft2(string &line, string str);
void deleteFromLeftIteratively(string &line, string str);
void Tokenize2(string line, string str, vector<string> &v);
void Delete(string &line, string str);
void DeleteStartingAt(string &line, string str);
void strip(string &line);
void DeleteChar(string &str, const char &chr);
void ProcessLinesForReadingParameters(vector<string> &lines);
void readMatrix(string InputFile, Matrix &matrix);
void readVector(string inputFile, Vector &v);
bool WildCardCompare2(string str1, string str2);
bool WildCardCompare(string str1, string str2);
Real getValueOfReal(string variableName, string str);
bool getValueOfBool(string variableName, string str);
int getValueOfInt(string variableName, string str);
string stringReplace(string line, string strToReplace, string strFinal);
#endif
