/*
    JV Library
    Copyright (C) 2014  Jouko Juhani Virtanen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _PointsOnASphere_included_
#define _PointsOnASphere_included_

# include "TypeDef.h"
# include "MathUtils.h"
# include "VectorManip.h"

void MakePointsOnAHemiSphere(Real ThetaInc, Real NumSlices, vector<VectorStruct> &v)
{
        Real cosphi=1.0/NumSlices-1.0;
        Real sinphi;
        Real theta=pi/ThetaInc;
        VectorStruct temp;
        while (true)
        {
                sinphi=sqrt(1.0-cosphi*cosphi);
                temp.x=sinphi*cos(theta);
                temp.y=sinphi*sin(theta);
                temp.z=cosphi;
                SafePushBack(v, temp, "in MakePointsOnAHemiSphere");
                theta+=2.0*pi/ThetaInc;
                if (theta>2.0*pi)
                {
                        theta=pi/ThetaInc;
                        cosphi+=2.0/NumSlices;
                        if (cosphi>-0.9/NumSlices) break;
                }
        }
}

#endif
